#include <avr/interrupt.h>
#include <stdio.h>
#include <string.h>	
#include <avr/io.h>	
#include <avr/eeprom.h>	
	
#include "mmc.h"
#include "fat.h"
#include "usart.h"

unsigned int bytecounter = 0;
unsigned char Buffer[512];
unsigned char Buffer2[512];
unsigned char *readPtr = Buffer;
volatile unsigned char ready_read = 0;

ISR (TIMER1_OVF_vect) {

   TCNT1 = 65535 - ((F_CPU/8000));
   OCR0 = readPtr[bytecounter];
   bytecounter++;
   if(bytecounter > 511) {
      bytecounter = 0;
      ready_read = 1;
   }

}


void playWav(unsigned char *file) {

   unsigned int Clustervar = 0;
   unsigned long Size = 0;
   unsigned char Dir_Attrib = 0;
   
   if ( fat_search_file(file ,&Clustervar,&Size,&Dir_Attrib,Buffer) != 1 ) {
      return;
   }

   readPtr = Buffer;  
   ready_read = 0;
   fat_read_file (Clustervar,Buffer,0); // Seite 1 laden
   
   sei();
   for (int i = 0; i < Size/512; i+=2) {	
      if (i != 0) {
         fat_read_file (Clustervar,Buffer,i); // Seite 1 laden
         while(!ready_read); // Seite 2 ist gelesen
	 readPtr = Buffer;  // Seite 1 lesen
	 ready_read = 0;
      }
      fat_read_file (Clustervar,Buffer2,i+1); // Seite 2 laden
      while(!ready_read); // Seite 1 ist gelesen
      readPtr = Buffer2; // Seite 2 lesen
      ready_read = 0;
   }
   cli();
}	


int main (void) {

   usart_init(9600);
   
   //Set TIMER0 (PWM OC0 Pin)
   DDRB |= (1<<3);
   TCCR0 |= (1<<WGM01|1<<WGM00|1<<COM01|1<<CS00);
   OCR0 = 128;

   DDRA = 0x00;
   PORTA = 0xFF;


   //Set TIMER1 
   TIMSK |= (1 << TOIE1);
   TCCR1B = (1<<CS10);
   TCNT1 = 65535 - (F_CPU/8000);
	
   //Initialisierung der MMC/SD-Karte
   usart_write("System Ready!\r\n");	
   while ( mmc_init() != 0) {
      usart_write("** Keine MMC/SD Karte gefunden!! **\r\n");	
   }
   usart_write("Karte gefunden!!\n");
   fat_init();

   while(1) {

      usart_write("PortA = %x\r\n", PINA);
      if (PINA == 0xfe) {
         playWav("1.wav");
      } 
      if (PINA == 0xfd) {
         playWav("2.wav");
      }
      if (PINA == 0xfb) {
         playWav("3.wav");
      }
      if (PINA == 0xf7) {
         playWav("4.wav");
      } 
      if (PINA == 0xef) {
         playWav("5.wav");
      }
      if (PINA == 0xdf) {
         playWav("6.wav");
      }
      if (PINA == 0xbf) {
         playWav("7.wav");
      }
      if (PINA == 0x7f) {
         playWav("8.wav");
      }
   }


  return 0;
}

